function [ x,y ] = GeoUTM(Lon,Lat,Z )
% GeoUTM tranforma un Geograficas a UTM
%_________________________________________________________________________
% conversion a UTM  modificado de deg2utm(Lat,Lon)
% Author: Rafael Palacios,  Universidad Pontificia Comillas. Apr/06, Jun/06
% http://www.mathworks.com/matlabcentral/fileexchange/10915-deg2utm/content/deg2utm.m
%-------------------------------------------------------------------------
        for i=1:length(Lon)
            la=Lat(i); lo=Lon(i);
            sa = 6378137.000000 ; sb = 6356752.314245;    % WGS84
           %sa = 6378388.000000 ; sb = 6356911.924        % HAYFORD (1924) - ED50
            e = ( ( ( sa ^ 2 ) - ( sb ^ 2 ) ) ^ 0.5 ) / sa;
            e2 = ( ( ( sa ^ 2 ) - ( sb ^ 2 ) ) ^ 0.5 ) / sb;
            e2cuadrada = e2 ^ 2; c = ( sa ^ 2 ) / sb;
            alpha = ( sa - sb ) / sa; ablandamiento = 1 / alpha;   % 1/f              
            lat = la * ( pi / 180 );  lon = lo * ( pi / 180 );
            Huso= Z;  S = ( ( Huso * 6 ) - 183 );
            deltaS = lon - ( S * ( pi / 180 ) ); a = cos(lat) * sin(deltaS);
            epsilon = 0.5 * log( ( 1 +  a) / ( 1 - a ) );
            nu = atan( tan(lat) / cos(deltaS) ) - lat;
            v = ( c / ( ( 1 + ( e2cuadrada * ( cos(lat) ) ^ 2 ) ) ) ^ 0.5 ) * 0.9996;
            ta = ( e2cuadrada / 2 ) * epsilon ^ 2 * ( cos(lat) ) ^ 2;
            a1 = sin( 2 * lat );    a2 = a1 * ( cos(lat) ) ^ 2;
            j2 = lat + ( a1 / 2 );  j4 = ( ( 3 * j2 ) + a2 ) / 4;
            j6 = ( ( 5 * j4 ) + ( a2 * ( cos(lat) ) ^ 2) ) / 3;
            alfa = ( 3 / 4 ) * e2cuadrada; beta = ( 5 / 3 ) * alfa ^ 2;
            gama = ( 35 / 27 ) * alfa ^ 3; 
            Bm = 0.9996 * c * ( lat - alfa * j2 + beta * j4 - gama * j6 );
            xx = epsilon * v * ( 1 + ( ta / 3 ) ) + 500000;
            yy = nu * v * ( 1 + ta ) + Bm; 
            if yy < 0, yy= yy + 10000000; end
            x(i)=xx;
            y(i)=yy;
        end


