function [ Lon, Lat ] = UTMGeo(ux,uy,Z,H)
%UTMGeo transform UTM  to Geographic
%_________________________________________________________________________
% conversion a DEGREES  modificado de utm2deg(Lat,Lon)
% Author: Rafael Palacios, Universidad Pontificia Comillas. Apr/06, Jun/06
% http://www.mathworks.com/matlabcentral/fileexchange/10914-utm2deg/content/utm2deg.m
%-------------------------------------------------------------------------
    for i=1:1:length(ux)
        xxx=ux(i); yyy=uy(i);
        sa = 6378137.000000;  sb = 6356752.314245; %     WGS84
       %sa = 6378388.000000;  sb = 6356911.924     %    HAYFORD (1924) - ED50
        e2 = ( ( ( sa ^ 2 ) - ( sb ^ 2 ) ) ^ 0.5 ) / sb;
        e2c = e2 ^ 2;  c = ( sa ^ 2 ) / sb; X = xxx - 500000;
        if H == 'S' || H == 's', Y = yyy - 10000000 ; else  Y = yyy;  end   
        S = ( ( Z * 6 ) - 183 ); lat =  Y / ( 6366197.724 * 0.9996 );                                    
        v = ( c / ( ( 1 + ( e2c * ( cos(lat) ) ^ 2 ) ) ) ^ 0.5 ) * 0.9996;  %----
        a = X / v; a1 = sin( 2 * lat ); a2 = a1 * ( cos(lat) ) ^ 2;
        j2 = lat + ( a1 / 2 );  j4 = ( ( 3 * j2 ) + a2 ) / 4;
        j6 = ( ( 5 * j4 ) + ( a2 * ( cos(lat) ) ^ 2) ) / 3;
        alfa = ( 3 / 4 ) * e2c;
        beta = ( 5 / 3 ) * alfa ^ 2;  gama = ( 35 / 27 ) * alfa ^ 3;
        Bm = 0.9996 * c * ( lat - alfa * j2 + beta * j4 - gama * j6 );
        b = ( Y - Bm ) / v;
        Epsi = ( ( e2c * a^ 2 ) / 2 ) * ( cos(lat) )^ 2;
        Eps = a * ( 1 - ( Epsi / 3 ) ); nab = ( b * ( 1 - Epsi ) ) + lat;
        senoheps = ( exp(Eps) - exp(-Eps) ) / 2;
        Delt = atan(senoheps / (cos(nab) ) );
        TaO = atan(cos(Delt) * tan(nab));
        longitude = (Delt *(180 / pi ) ) + S;
        latitude = ( lat + ( 1 + e2c* (cos(lat)^ 2) - ( 3 / 2 ) *...
            e2c * sin(lat) * cos(lat) * ( TaO - lat ) ) *...
           ( TaO - lat ) ) * (180 / pi);
        Lat(i)=latitude;  Lon(i)=longitude; 
    end 
